----------------------------------------------------------------------------------
-- Engineer: Catherine Lagunzad
-- Create Date: 11/27/2017 04:37:27 PM
-- Description: 
----------------------------------------------------------------------------------
-------------------------------------------
--5-BIT COUNTER WITH ENABLE
-------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity five_bit_counter_en is
    Port ( EN : in STD_LOGIC;
           CLK : in STD_LOGIC;
           Timer_initial_val : in STD_LOGIC_VECTOR (4 downto 0);
           counter_out : out STD_LOGIC_VECTOR (4 downto 0));
end five_bit_counter_en;

architecture Behavioral of five_bit_counter_en is

--T flip flops
component T_flip_flop is
    Port ( EN : in STD_LOGIC;
           T : in STD_LOGIC;
           T_initial : in STD_LOGIC;
           CLK : in STD_LOGIC;
           Q : out STD_LOGIC;
           Qn : out STD_LOGIC);
end component;


--intermediate signal declaration
signal Qn : STD_LOGIC_VECTOR (3 downto 0);
signal check : STD_LOGIC_VECTOR (3 downto 1);

begin

tff0 : t_flip_flop
    port map (EN => EN,
              T => '1',
              T_initial => Timer_initial_val(0),
              CLK => CLK,
              Qn => Qn(0));
              
counter_out(0) <= Qn(0);   --outputs counter_out(0)

tff1 : T_flip_flop
    port map (EN => EN,
              T => Qn(0),
              T_initial => Timer_initial_val(1),
              CLK => CLK,
              Qn => Qn(1));

counter_out(1) <= Qn(1);   --outputs counter_out(1)
check(1) <= Qn(0) NAND Qn(1);  --two previous bits are all 0's

tff2 : T_flip_flop
    port map (EN => EN,
              T => check(1),
              T_initial => Timer_initial_val(2),
              CLK => CLK,
              Qn => Qn(2));

counter_out(2) <= Qn(2);   --outputs counter_out(2)
check(2) <= check(1) NAND Qn(2);  --three previous bits are all 0's

tff3 : t_flip_flop
    port map (EN => EN,
              T => check(2),
              T_initial => Timer_initial_val(3),
              CLK => CLK,
              Qn => Qn(3));

counter_out(3) <= Qn(3);    --outputs counter_out(3)
check(3) <= check(2) NAND Qn(3);

tff4 : t_flip_flop
    port map (EN => EN,
              T => check(3),
              T_initial => Timer_initial_val(4),
              CLK => CLK,
              Qn => counter_out(4));    --outputs counter_out(4)


end Behavioral;
